; Example 0 of genlib
;
; Show :
;	* gray mode
;	* Sprite routine 16 x 16
;	* WaitKey

	xdef	_main
	xdef	_ti89
	xdef	_ti92plus
	
	include "tios.h"
	include "genlib.h"

_main:
	; Init Genlib
	jsr	genlib::init

	; Init the DScreen
	jsr	genlib::init_dscreen
	move.w	d0,Handle
	move.l	a0,Screen

	; Set genlib to work on this DScreen
	move.l	Screen(PC),d0
	jsr	genlib::set_dscreen_int			; Set the Displayed DScreen
	jsr	genlib::set_dscreen_function		; Set the Working DScreen

	; Clear the Working DScreen
	jsr	genlib::cls

	; Set the position of the sprite layer
	move.w	#10,genlib::sprite_scr_x
	move.w	#-20,genlib::sprite_scr_y

	; Set the origine of the tiles of the sprite layer
	lea	Sprite(pc),a0
	move.l	a0,genlib::sprite_tile_adr
	
	; Put the sprite
	move.w	#143,d0 	; x.
	move.w	#27,d1		; y
	move.w	#0,d2		; No
	jsr	genlib::put_sprite_16

	; Wait a key
	jsr	genlib::wait_a_key

	; Free the DScreen
	move.w	Handle(Pc),-(a7)
	jsr	tios::HeapFree
	addq.l	#2,a7

	; Quit
	jsr genlib::quit
	rts

Sprite:
        dc.w %10000010101 ; Premiere ligne du sprite de l'ecran 1
        dc.w %10010101011 ; Premiere ligne du sprite de l'ecran 2
        dc.w %10000010101 ; ligne 2 | ecran 1
        dc.w %10010101011 ; ligne 2 | ecran 2
        dc.w %10000010101 ; ligne 3 | ecran 1
        dc.w %10010101011 ; ligne 3 | ecran 2
        dc.w %10000010101 ; ligne 4 | ecran 1
        dc.w %10010101011 ; ligne 4 | ecran 2
        dc.w %10000010101 ; ligne 5 | ecran 1
        dc.w %10010101011 ; ligne 5 | ecran 2
        dc.w %10000010101 ; ligne 6 | ecran 1
        dc.w %10010101011 ; ligne 6 | ecran 2
        dc.w %10000010101 ; ligne 7 | ecran 1
        dc.w %10010101011 ; ligne 7 | ecran 2
        dc.w %10000010101 ; 8
        dc.w %10010101011 ; 8
        dc.w %10000010101 ; 9
        dc.w %10010101011 ; 9
        dc.w %10000010101 ; 10
        dc.w %10010101011 ; 10		
        dc.w %10000010101 ; 11		
        dc.w %10010101011 ; 11
        dc.w %10000010101 ; 12
        dc.w %10010101011 ; 12
        dc.w %10000010101 ; 13
        dc.w %10010101011 ; 13
        dc.w %10000010101 ; 14
        dc.w %10010101011 ; 14
        dc.w %10000010101 ; 15
        dc.w %10010101011 ; 15
        dc.w %10000010101 ; 16
        dc.w %10010101011 ; 16

Handle:    dc.w    0
Screen:    dc.l    0

     end

