; Example 1 of genlib
;
; Show :
;	* Sprite routine 16 x 16
;	* Flip horizontal and vertical for the sprite routine
;	* Window
;	* gray mode
;	* Zoom
;	* WaitKey

	include	tios.h
	include genlib.h

	xdef	_main
	xdef	_comment
	xdef	_ti92plus
	xdef	_ti89

_main:
	jsr	genlib::init		; 4 gray mode

	jsr	genlib::init_dscreen	; Init a new double screen
	tst.w	d0			; Memory ?
	beq	fail			; yes :<

	move.w	d0,MyHd			; Save the handle
	move.l	a0,Screen		; Save the adress of the dscreen

	move.l	Screen(PC),d0
	jsr	genlib::set_dscreen_int
			; the interruption works with the dscreen D0
	jsr	genlib::set_dscreen_function	
			; the functions work with the dscreen D0

	jsr	genlib::cls		; Clear it

	clr.w	genlib::sprite_scr_x	; Clear Sprite_Scroll_X coordinate
	clr.w	genlib::sprite_scr_y	; Clear "_"_Y "
	lea	Sprite_Tile(PC),a0	; Set sprite tile (16x16)
	move.l	a0,genlib::sprite_tile_adr

	; Display the sprite 
	moveq	#10,d0			; x
	moveq	#18,d1			; y
	moveq	#0,d2			; Number
	jsr	genlib::put_sprite_16	; Put sprite d2.w at (d0.w, d1.w)
					; on the current dscreen !
	jsr	genlib::wait_a_key	; Wait a key (direct acces)
	; Display the same sprite but with horizontal flipping (Mirror)
	moveq	#30,d0			; x
	moveq	#18,d1			; y
	moveq	#0,d2			; number
	jsr	genlib::put_sprite_16_flip_h
					; Put sprite d2.w at (d0.w, d1.w)
					; Horizontal flip
	jsr	genlib::wait_a_key	; Wait a key (direct acces)
	; Display the same sprite but with vertical flipping (Mirror)
	moveq	#50,d0
	moveq	#18,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16_flip_v
					; Put sprite d2.w at (d0.w, d1.w)
					; Vertical flip
	jsr	genlib::wait_a_key	; Wait a key (direct acces)
	; Display the same sprite but with horizontal & vertical flipping (Mirror)
	moveq	#70,d0
	moveq	#18,d1
	moveq	#0,d2
	jsr	genlib::put_sprite_16_flip_hv
					; Put sprite d2.w at (d0.w, d1.w)
					; Horizontal and vertical flip

	jsr	genlib::wait_a_key	; Wait a key (direct acces)
	; Window
	jsr	genlib::clear_window	; Clear the window
	moveq	#0,d0			; X
	moveq	#0,d1			; Y
	lea	_comment(Pc),a0		; String
	move.l	genlib::window,a1	; Screen
	jsr	genlib::put_medium_string	; Display a string on the window
	jsr	genlib::copy_window	; Copy the window to the current dscreen

	jsr	genlib::wait_a_key	; Wait a key (direct acces)

	jsr	genlib::cls

	moveq	#10,d0
	moveq	#15,d1
	moveq	#0,d2
	move.l	#(65536/4),d4
	move.l	#(65536*4),d5
	jsr	genlib::put_sprite_16_zoom
	jsr	genlib::wait_a_key	; Wait a key (direct acces)

	move.w	MyHd(PC),-(a7)
	jsr	tios::HeapFree		; Free allocated buffer for Dscreen
	addq.l	#2,a7
fail:
	jsr	genlib::quit		; Restore Black & White mode
	rts


MyHd:	dc.w	0
Screen	dc.l	0

Sprite_Tile
	INCBIN "fernand.bin"

_comment:
	dc.b	"Example 1",0
	end
