#include "doors.h"
#include "all.h"

#include "genc.h"


/* Compil with: tigcc genSM16.c genTM16.asm -O2 */

int	_ti89, _ti92plus;

extern	MAP_SUB	map[];
extern	unsigned char	map2[];
extern	SPRITE_16	tile[];

void	move_plane(PLANE *P, POINT *DIR)
{
	P->xs += DIR->x;
	P->ys += DIR->y;
	
	if ((P->xs > P->size*16-240) || (P->xs < 3))	DIR->x *=-1;
	if ((P->ys > P->size*16-128) || (P->ys < 3))	DIR->y *=-1;	
}

int	_main()
{
	HANDLE	hd;
	DSCREEN	*ds1, *ds2;
	PLANE	*P1, *P2;
	POINT	DIR1 = {2,2}, DIR2 = {1,1};
	short	tmp = 0;
	int	i,j;
	
	gl_init();
	gl_init_dscreen(&ds1, &hd);
	if (hd == 0) goto exit;
	gl_push_hd(hd);
	gl_init_dscreen(&ds2, &hd);
	if (hd == 0) goto exit;
	gl_push_hd(hd);

	gl_set_dscreen_int(ds1);
	gl_set_dscreen_function(ds2);
	gl_cls();
	
	gl_change_update();	/* Use real size X for the plane */
	P1 = gl_init_plane((unsigned char *) map, tile, 32);
	if (P1 == NULL)	goto exit;
	gl_push_hd(P1->handle);
	P2 = gl_init_plane(map2, tile, 16);
	if (P2 == NULL)	goto exit;
	gl_push_hd(P2->handle);
	
	P1->xs = 16;
	P1->ys = 17;
	P2->xs = 32;
	P2->ys = 33;
	
	gl_wait_no_key();
	

	while	(gl_keypressed() == 0)
		{
		/* Deplacement du scrolling */
		move_plane(P1, &DIR1);
		move_plane(P2, &DIR2);

		/* Modification palette */
		for(i = 0 ; i < 5 ; i++)
		for(j = 0 ; j < 5 ; j++)
			if ((i&3) && (j & 3))
				map[(P1->ys/16+3+j)*P1->size+P1->xs/16+4+i].pal = (i+j) & 3;
			else
				map[(P1->ys/16+3+j)*P1->size+P1->xs/16+4+i].pal = 5;

		/* Refresh P1 */
		gl_refresh_plane(P1);
		
		/* Affichage des plans */
		gl_update_vscreen_max16(P1);
		gl_update_vscreen_16(P2);

		while	(gl_timer == 0);

		gl_put_plane(P2);
		gl_put_fgrd_plane(P1);
		
		/* Double buffer */
		tmp = !tmp;
		if (tmp)
			{
			gl_set_dscreen_int(ds1);
			gl_set_dscreen_function(ds2);
			}
		else	{
			gl_set_dscreen_int(ds2);
			gl_set_dscreen_function(ds1);
			}
		
		/* Attend frame suivante */
		while (gl_timer <= 5) ;
		gl_timer = 0;
		}

	/* Oui un label !!! C'est parce c'est le + simple ! */
exit:
	gl_free_hd();
	gl_quit();	
}
